// ConformGidlet.java
// Angle conserving transformation of regular grid

import ch.aplu.gidlet.*;

public class ConformGidlet extends Gidlet
{
  private double min = -5;
  private double max = 5;
  private double step = (max - min) / 400.0;
  private Complex reStep = new Complex(step, 0);
  private Complex imStep = new Complex(0, step);
  private MPanel p = new MPanel(min, max, min, max);

  public void main()
  {
    p.line(min, 0, max, 0); // Real axis
    p.line(0, min, 0, max); // Imaginary axis
    p.enableFlush(false);
    transform();
  }

  private void transform()
  {
    // Transform horizontal grid lines
    p.color(GREEN);
    Complex z = new Complex(min, min);
    while (z.img < max && !isExiting())
    {
      z = new Complex(min, z.img);
      cmove(f(z));
      while (z.real < max)
      {
        cdraw(f(z));
        z.add(reStep);
      }
      z.add(imStep);
      p.flush();
    }

    // Transform vertical grid lines
    p.color(RED);
    z = new Complex(min, min);
    while (z.real < max && !isExiting())
    {
      z = new Complex(z.real, min);
      cmove(f(z));
      while (z.img < max)
      {
        cdraw(f(z));
        z.add(imStep);
      }
      z.add(reStep);
      p.flush();
    }
  }

  private Complex f(Complex z)

  // function f(z) = 1/z
  {
    if (z.modulus() != 0)
    {
      Complex one = new Complex(1, 0);
      one.divide(z);
      return one;
    }
    else
      return new Complex(0, 0);
  }

  private void cmove(Complex z)
  {
    p.move(z.real, z.img);
  }

  private void cdraw(Complex z)
  {
    p.draw(z.real, z.img);
  }
}
