// FileGidlet.java
// Test important features of MFile

import ch.aplu.gidlet.*;

public class FileGidlet extends Gidlet
{
  private final String filename = "dates.txt";
  private final String dirname = "Gidlet/";  // Trailing /
  private MConsole c = new MConsole();

  public void main()
  {
    MFile mf = new MFile();
    boolean rc; // Return code

    c.print("Checking FileConnection...");
    if (!MFile.isFileConnectionSupported())
    {
      c.println("not supported");
      return;
    }
    else
      c.println("OK");

    c.println("Enumerate roots...");
    rc = mf.findFirstRoot();
    if (rc)
    {
      c.println("first: " + mf.getPath());
      while (mf.findNextRoot())
        c.println("next: " + mf.getPath());
    }
    else
    {
      c.println("no root found");
      return;
    }

    String myRoot = mf.getPath();

    c.println("Enumerate the files in " + myRoot + "...");
    rc = mf.findFirst();
    if (rc)
    {
      c.println("first: " + mf.getPath());
      while (mf.findNext())
        c.println("next: " + mf.getPath());
    }
    else
      c.println("got false");

    mf.setPath(myRoot + dirname);
    c.print("Looking for directory " + mf.getPath() + "...");
    if (mf.isDirectory())
      c.println("found");
    else
    {
      c.println("not found");
      c.print("Creating directory...");
      if (mf.createDir())
        c.println("OK");
      else
      {
        c.println("failed");
        return;
      }
    }

    mf.setPath(mf.getPath() + filename);
    c.print("Looking for file " + mf.getPath() + "...");
    if (mf.exists())
      c.println("found");
    else
    {
      c.println("not found");
      c.print("Creating file...");
      if (mf.createFile())
        c.println("OK");
      else
      {
        c.println("failed");
        return;
      }
    }

    StringBuffer data = new StringBuffer();
    for (int i = 1; i <= 3; i++)
    {
      data.append("line #" + i + "\n");
    }
    c.println("Writing data to file\n" + mf.getPath() + "...");
    rc = mf.write(data.toString());
    if (!rc)
    {
      c.println("write() failed.");
      return;
    }
    c.println("Success");

    c.println("Reading data from file\n" + mf.getPath() + "...");
    String content = mf.read();
    if (content == null)
    {
      c.println("read() failed.");
      return;
    }
    c.println("Success");
    c.println("Content of file:");
    c.println(content);
    c.println();
    c.println("all done");
  }
}

