// VocGidlet.java

import ch.aplu.gidlet.*;
import javax.microedition.lcdui.*;

public class VocGidlet extends Gidlet
{

  private MPanel p = new MPanel(0, 10, 0, 10);
  private MFile mf = new MFile();
  private String[] question;
  private String[] answer;
  private int size;
  private int curIndex;
  private Command nextCommand = new Command("Next", Command.OK, 1);
  private Command showCommand = new Command("Show", Command.EXIT, 1);
  private Command exitCommand = new Command("Exit", Command.EXIT, 1);

  public void main()
  {
    mf.findFirstRoot();
    mf.setPath(mf.getPath() + "voc/");
    if (mf.getPath().equals("c:/"))  // No access on c:, try next

      mf.findNextRoot();
    if (!mf.exists())
      p.label("voc not found", 5);
    mf.setPath(mf.getPath() + "lesson1");
    if (!mf.canRead())
    {
      p.label(" lesson1 not accessible", 5);
      return;
    }

    String input = mf.read();
    String[] output = split(input, "\n");

    size = output.length - 1;
    // Last line terminates with separator,
    // so the last record is empty

    if (size == -1)
    {
      p.label(" Voc file empty", 5);
      return;
    }

    question = new String[size];
    answer = new String[size];

    for (int i = 0; i < size; i++)
    {
      String[] part = split(output[i], "|");
      question[i] = part[0];
      answer[i] = part[1];
    }

    p.removeExitButton();
    p.addCommand(nextCommand);
    p.addCommand(showCommand);
    layout();
    fontVoc();
    p.label("   " + question[0], 9);
    fontRem();
    p.label("  Record: " + 1 + " of " + size, 5);
    p.label("  Use Next for next question", 4);
    p.label("  Use Show to show answer, if necessary", 3.5);
    p.setCommandListener(new MyCommandListener());
  }

  // ------------- Inner class MyCommandListener -------------
  private class MyCommandListener implements CommandListener
  {

    public void commandAction(Command c, Displayable d)
    {
      if (c == exitCommand)
        notifyDestroyed();

      if (c == nextCommand)
      {
        curIndex++;
        if (curIndex == size)
        {
          layout();
          fontRem();
          p.label(" Lesson finished", 5);
          p.removeCommand(nextCommand);
          p.removeCommand(showCommand);
          p.addCommand(exitCommand);
        }
        else
        {
          layout();
          fontVoc();
          p.label("   " + question[curIndex], 9);
          fontRem();
          p.label("  Record: " + (curIndex + 1) + " of " + size, 5);
          p.removeCommand(exitCommand);
          p.addCommand(showCommand);
        }
      }

      if (c == showCommand)
      {
        fontVoc();
        p.label("   " + answer[curIndex], 6.5);
        p.removeCommand(showCommand);
        p.addCommand(exitCommand);
      }
    }
  }

  void fontVoc()
  {
    p.color(BLUE);
    p.setFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_LARGE);
  }

  void fontRem()
  {
    p.color(BLACK);
    p.setFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
  }

  void layout()
  {
    p.erase();
    fontRem();
    p.title("Deutsch - English: lesson1");
    p.label("  Deutsch", 10);
    p.label("  Englisch", 7.5);
    p.color(LIGHTGRAY);
    p.rectangle(0.2, 9.3, 9.5, 8);
    p.rectangle(0.2, 6.8, 9.5, 5.5);
  }
}
