// ShareConstants.java

/*
  This software is part of the Gidlet framework.
  It is Open Source Free Software, so you may
    - run the code for any purpose
    - study how the code works and adapt it to your needs
    - integrate all or parts of the code in your own programs
    - redistribute copies of the code
    - improve the code and release your improvements to the public
  However the use of the code is entirely your responsibility.
 */

/* History:
V1.00 - Aug 2007: First public release
V1.01 - Aug 2007: Minor changes in documentation
V1.02 - Sep 2007: Added addOkButton(String label)
V1.03 - Oct 2007: Change show() to wait up to 5 s to get shown
V1.04 - Nov 2007: Added isEmulator(), don't start LightThread when
                  running in emulator
V1.05 - Apr 2008: Added class MFile to integrate file access (JSR 75)
V1.06 - Apr 2008: Added Gidlet.split() for splitting strings
V1.07 - Apr 2008: Added MPanel.setFont()
V1.08 - Apr 2008: openfc(), closefc() in MFile (private)
V1.09 - Apr 2008  main() terminates by a RuntimeException when the Exit button
                  is hit in a blocking readXXX() or showMessage() call.
                  Added Gidlet.isExiting() to check this condition
V1.10 - Apr 2008: Some modifications to class AudioPlayer for better error recovery
                  Added Gidlet setDebug()/getDebug() to get some debug information
V1.11 - Apr 2008: Added Gidlet.readFile() to read text files from resources
V1.12 - May 2008: Added showDebug() to redirect debug messages.
                  Changed several methods from public to protected.
                  Removed nokia classes from jar file.
                  Fixed bug: disabling screen saver now works again
V1.13 - May 2008: Added class StringStore, a wrapper for RecordStore
V1.14 - Aug 2008: Classes to handle NXT bricks from Lego, Bluetooth classes
                  moved to package ch.aplu.bluetooth
V1.15 - Sep 2008: Added class TextArea, some internal changes in package
                  ch.aplu.bluetooth
V1.16 - Mar 2009: Screensaver removed due to incompatibility with Nokia classes
V1.17 - Mar 2009: Bugs fixed: Turtle.isHidden(), Turtle.isPenUp() now return
                  inverted value
V1.18 - Apr 2009: Search nxtjlib.properties also in subdir ch/aplu/nxt/properties
V1.19 - May 2010: Flush Bluetooth output stream in NxtRobot.java

 */

package ch.aplu.gidlet;

interface SharedConstants
{
  String ABOUT =
    "2003-2010 Aegidius Pluess\n" +
    "OpenSource Free Software\n" +
    "http://www.aplu.ch\n" +
    "All rights reserved";

  String VERSION = "1.19 - May 2010";
}
