// TurtlePane.java, Java ME version
// Platform (Java SE, ME) dependent code
// Should be visible in package only. Not included in Javadoc

/*
This software is part of the NxtJLib library.
It is Open Source Free Software, so you may
- run the code for any purpose
- study how the code works and adapt it to your needs
- integrate all or parts of the code in your own programs
- redistribute copies of the code
- improve the code and release your improvements to the public
However the use of the code is entirely your responsibility.
 */

package ch.aplu.nxt.platform;

import javax.microedition.lcdui.*;
import ch.aplu.nxt.*;
import ch.aplu.gidlet.*;

public class TurtlePane extends MConsole
{
  // ------------- Inner class MyCommandListener -------------
  private class MyCommandListener implements CommandListener
  {
    public void commandAction(Command c, Displayable d)
    {
      if (c == exitCommand)
        robot.exit();
    }
  }

  private MConsole console = null;
  private NxtRobot robot;
  private Command exitCommand = new Command("Exit", Command.EXIT, 1);

  public TurtlePane(NxtRobot robot)
  {
    super(0, Gidlet.WHITE, Gidlet.BLACK, 2);
    removeExitButton();
    addCommand(exitCommand);
    setCommandListener(new MyCommandListener());
    this.robot = robot;
    println("List of turtle commands:");
    show();
  }
}

